import java.lang.reflect.Constructor;
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.util.Scanner;

/* 1. Zjistit nazev tridy (predpisu), podle ktere instance vznikla
 * 2. Tuto zjistenou tridu ziskat
 * 3. Z teto ziskane tridy vytahnout pole nazvu konstruktoru
 * 4. Z teto ziskane tridy vytahnout pole nazvu metod
 * 5. Nastavit pristup k atributum tridy
 * 6. Vypsat modifikatory promennych, datove typy, jejich nazvy a pokusi ze z nich vytahnout hodnoty
 ***********************************************************************************************************
 *Program realne nic nedela, ma pouze demonstrovat princip a pouziti reflexe v jazyce JAVA. Jeho autorem
 *je Jaroslav Polivka, clen komunity itnetwork. Autor se timto velmi snazi ziskat placku a oceneni na siti.
 */

public class Lustr {
	
private Zarovicka edisonka;

		public Lustr(){
		System.out.println("Nezapomen prosim do lustru namontovat zarovku,");
		System.out.println("takovy lustr bez zarovky by nam byl k nicemu!");
		edisonka=null;
		}
	
		public void namontujZarovku(Zarovicka zarovicka){
					
		edisonka=zarovicka;
		edisonka.namontovano=true;
		final String strBoolean = "boolean";
		final String strChar = "char";
		final String strByte = "byte";
		final String strShort = "short";
		final String strInt = "int";
		final String strLong = "long";
		final String strFloat = "float";
		final String strDouble = "double";
				
		System.out.println("\nLustr: Namontoval jsi zarovku, pokusim se ti o ni neco zjistit...\n");	
		String nazevTridy= ""+ edisonka.getClass().getName(); //1.zjisti nazev tridy, podle ktere jsi vznikla
		
		System.out.println("Zarovku, kterou jsi do me namontoval, vznikla dle predpisu: " +nazevTridy +"\n");	
		
		try {
		Class<?> c = Class.forName(nazevTridy); 						
		Constructor<?> [] konstruktory = c.getDeclaredConstructors(); 
		Method metody[] = c.getDeclaredMethods(); 	
		Field atributy[]= c.getDeclaredFields();
						
	
		System.out.println("Konstruktory teto tridy:");
		for(Constructor<?> k : konstruktory){ //procvicit si foreach cylkus... 					
		System.out.println(k.toString());
		}
	
		System.out.println("\nMetody teto tridy: ");
		for (int i = 0; i < metody.length; i++) //procvicit si klasicky for cyklus...
		System.out.println(metody[i].toString());
	
		System.out.println("\nAtributy s hodnotami teto tridy: ");
		for (int i = 0; i < atributy.length; i++) 
		{
		atributy[i].setAccessible(true);								//zpristupni i privatni promenne
		System.out.print(Modifier.toString(atributy[i].getModifiers())); //vypise modifikatory
		System.out.print(" " + atributy[i].getType() + " ");			//vypise datovy typ
		System.out.print(atributy[i].getName().toString());			//vypise nazev promenne
				
		if( atributy[i].getType().toString().equals(strByte)||			// Je v promennych ulozene cislo? 
				atributy[i].getType().toString().equals(strShort)||
				atributy[i].getType().toString().equals(strInt)||
				atributy[i].getType().toString().equals(strLong)||
				atributy[i].getType().toString().equals(strFloat)||
				atributy[i].getType().toString().equals(strDouble)) 
			System.out.println(" "+ atributy[i].getDouble(edisonka));
		
		else if (strChar.equals(atributy[i].getType().toString()) )		// Je v promennych ulozeny znak?	
			System.out.println(" "+ atributy[i].getChar(edisonka));
		
		else if( strBoolean.equals(atributy[i].getType().toString()) )		// Je v promennych ulozena pravdivost?		
			System.out.println(" "+ atributy[i].getBoolean(edisonka));
				
		else System.out.println(" Neumim zjistit hodnotu!");			// Jine typy neumime zjistit
		}
		
		} // konec try
		
				
		catch (Throwable e) { 	// vyhodit pripadne vyjimky
		System.err.println(e);
		}	
				
}//namontuj zarovku konec
		

		public static void main(String[] args) {

		System.out.println("**********************************************************************");	
		System.out.println("*Vitej v programu Lustr, program realne nic nedela, pouze demonstruje*");	
		System.out.println("*  pouziti schopnosti jazyka tzv. Reflexe. Napsal clen itnetwork.cz  *"); 
		System.out.println("* Jaroslav Polivka pro ucel ucasti v soutezi Machr na OOP - Reflexe  *");
		System.out.println("**********************************************************************");
						
		Lustr lustr = new Lustr();
		Zarovicka zarovicka = new Zarovicka(100,30);
		
		Scanner sc = new Scanner(System.in, "Windows-1250");
		System.out.println("\nZasroubovani zarovky do lustru - klavesa 1 a pak enter");
		System.out.println("Ukonceni programu - stisk jakekoli jine klavesy a enter");
		int volba = Integer.parseInt(sc.nextLine());
		
		if (volba == 1)lustr.namontujZarovku(zarovicka);
		else System.out.println("Tak a jsme po tme.");
		
		System.out.println("\nDekuji za pouziti programu");
		sc.nextLine();
		
		}

}
